// RcANV{

#include "DxLib.h"
#include <math.h>

// ֐vg^Cv錾 ---------------------------------------------------------------------------

void Input_Process( void ) ;			// ͏

void Player_Initialize( void ) ;		// vC[̏
void Player_Terminate( void ) ;			// vC[̌n
void Player_Process( void ) ;			// vC[̏
void Player_Move( VECTOR MoveVector ) ;		// vC[̈ړ
void Player_AngleProcess( void ) ;		// vC[̌ς鏈
void Player_PlayAnim( int PlayAnim ) ;		// vC[ɐVȃAj[VĐ
void Player_AnimProcess( void ) ;		// vC[̃Aj[V
void Player_ShadowRender( void ) ;		// vC[̉e`

void Stage_Initialize( void ) ;			// Xe[W̏
void Stage_Terminate( void ) ;			// Xe[W̌n

void Camera_Initialize( void ) ;		// J̏
void Camera_Process( void ) ;			// J̏

void Render_Process( void ) ;			// `揈



// Œl` -------------------------------------------------------------------------------------

// vC[֌W̒`
#define PLAYER_PLAY_ANIM_SPEED			250.0f		// Aj[Vx
#define PLAYER_MOVE_SPEED			30.0f		// ړx
#define PLAYER_ANIM_BLEND_SPEED			0.1f		// Aj[Ṽuhωx
#define PLAYER_ANGLE_SPEED			0.2f		// pxωx
#define PLAYER_JUMP_POWER			100.0f		// Wv
#define PLAYER_FALL_UP_POWER			20.0f		// 𓥂݊ÕWv
#define PLAYER_GRAVITY				3.0f		// d
#define PLAYER_MAX_HITCOLL			2048		// RW|S̍ő吔
#define PLAYER_ENUM_DEFAULT_SIZE		800.0f		// ͂̃|SoɎgp鋅̏TCY
#define PLAYER_HIT_WIDTH			200.0f		// 蔻JvZ̔a
#define PLAYER_HIT_HEIGHT			700.0f		// 蔻JvZ̍
#define PLAYER_HIT_TRYNUM			16		// ǉo̍ő厎s
#define PLAYER_HIT_SLIDE_LENGTH			5.0f		// x̕ǉoŃXCh鋗
#define PLAYER_SHADOW_SIZE			200.0f		// ȇ傫
#define PLAYER_SHADOW_HEIGHT			700.0f		// e鍂

// J֌W̒`
#define CAMERA_ANGLE_SPEED			0.05f		// 񑬓x
#define CAMERA_PLAYER_TARGET_HEIGHT		400.0f		// vC[Wǂꂾʒu𒍎_Ƃ邩
#define CAMERA_PLAYER_LENGTH			1600.0f		// vC[Ƃ̋
#define CAMERA_COLLISION_SIZE			50.0f		// J̓蔻TCY



// \̒` -------------------------------------------------------------------------------------

// ͏\
struct PADINPUT
{
	int		NowInput ;				// ݂̓
	int		EdgeInput ;				// ݂̃t[ŉꂽ{^̂݃rbgĂ͒l
} ;

// vC[\
struct PLAYER
{
	VECTOR		Position ;				// W
	VECTOR		TargetMoveDirection ;			// fׂ̃xNg
	float		Angle ;					// fĂ̊px
	float		JumpPower ;				// x̑x
	int		ModelHandle ;				// fnh
	int		ShadowHandle ;				// e摜nh
	int		State ;					// ( 0:~܂  1:  2:Wv )

	int		PlayAnim1 ;				// ĐĂAj[VP̃A^b`ԍ( -1:Aj[VA^b`ĂȂ )
	float		AnimPlayCount1 ;			// ĐĂAj[VP̍Đ
	int		PlayAnim2 ;				// ĐĂAj[VQ̃A^b`ԍ( -1:Aj[VA^b`ĂȂ )
	float		AnimPlayCount2 ;			// ĐĂAj[VQ̍Đ
	float		AnimBlendRate ;				// ĐĂAj[VPƂQ̃uh
} ;

// Xe[W\
struct STAGE
{
	int		ModelHandle ;				// fnh
} ;

// J\
struct CAMERA
{
	float		AngleH ;				// px
	float		AngleV ;				// px
	VECTOR		Eye ;					// JW
	VECTOR		Target ;				// _W
} ;



// ̐錾 ---------------------------------------------------------------------------------------

PADINPUT inp ;		// ͏̎̐錾
PLAYER pl ;		// vC[̎̐錾
STAGE stg ;		// Xe[W̎̐錾
CAMERA cam ;		// J̎̐錾




// ֐ ---------------------------------------------------------------------------------------

// ͏
void Input_Process( void )
{
	int Old ;

	// ЂƂÕt[̓͂ϐɂƂĂ
	Old = inp.NowInput ;

	// ݂̓͏Ԃ擾
	inp.NowInput = GetJoypadInputState( DX_INPUT_KEY_PAD1 ) ;

	// ̃t[ŐVɉꂽ{^̃rbgĂl EdgeInput ɑ
	inp.EdgeInput = inp.NowInput & ~Old ;
}

// vC[̏
void Player_Initialize( void )
{
	// W͌_
	pl.Position = VGet( 0.0f, 0.0f, 0.0f ) ;

	// ]l͂O
	pl.Angle = 0.0f ;

	// Wv͂͏Ԃł͂O
	pl.JumpPower = 0.0f ;

	// f̓ǂݍ
	pl.ModelHandle = MV1LoadModel( "DxChara.x" ) ;

	// e`p̉摜̓ǂݍ
	pl.ShadowHandle = LoadGraph( "Shadow.tga" ) ;

	// Ԃł́u~v
	pl.State = 0 ;

	// ԂŃvC[ׂ͂w
	pl.TargetMoveDirection = VGet( 1.0f, 0.0f, 0.0f ) ;

	// Aj[Ṽuh
	pl.AnimBlendRate = 1.0f ;

	// Ԃł̓Aj[V̓A^b`ĂȂɂ
	pl.PlayAnim1 = -1 ;
	pl.PlayAnim2 = -1 ;

	// ĂAj[VĐ
	Player_PlayAnim( 4 ) ;
}

// vC[̌n
void Player_Terminate( void )
{
	// f̍폜
	MV1DeleteModel( pl.ModelHandle ) ;

	// ep摜̍폜
	DeleteGraph( pl.ShadowHandle ) ;
}

// vC[̏
void Player_Process( void )
{
	VECTOR UpMoveVec ;		// {^uv͂Ƃ̃vC[̈ړxNg
	VECTOR LeftMoveVec ;		// {^uv͂Ƃ̃vC[̈ړxNg
	VECTOR MoveVec ;		// ̃t[̈ړxNg
	int MoveFlag ;			// ړǂ̃tO( 1:ړ  0:ړĂȂ )

	// [gt[̂ÿړp[^𖳌ɂ
	{
		MATRIX LocalMatrix ;

		// [U[s
		MV1ResetFrameUserLocalMatrix( pl.ModelHandle, 2 ) ;

		// ݂̃[gt[̍s擾
		LocalMatrix = MV1GetFrameLocalMatrix( pl.ModelHandle, 2 ) ;

		// y̕sړ𖳌ɂ
		LocalMatrix.m[ 3 ][ 2 ] = 0.0f ;

		// [U[sƂĕsړ𖳌ɂs[gt[ɃZbg
		MV1SetFrameUserLocalMatrix( pl.ModelHandle, 2, LocalMatrix ) ;
	}

	// vC[̈ړ̃xNgZo
	{
		// {^uvƂ̃vC[̈ړxNg̓J̎x𔲂
		UpMoveVec = VSub( cam.Target, cam.Eye ) ;
		UpMoveVec.y = 0.0f ;

		// {^uvƂ̃vC[̈ړxNg͏Ƃ̕xNgƂx̃vX̃xNgɐȕ
		LeftMoveVec = VCross( UpMoveVec, VGet( 0.0f, 1.0f, 0.0f ) ) ;

		// ̃xNg𐳋K( xNg̒PDOɂ邱 )
		UpMoveVec = VNorm( UpMoveVec ) ;
		LeftMoveVec = VNorm( LeftMoveVec ) ;
	}

	// ̃t[ł̈ړxNg
	MoveVec = VGet( 0.0f, 0.0f, 0.0f ) ;

	// ړǂ̃tOԂł́uړĂȂv\Oɂ
	MoveFlag = 0 ;

	// pbĥR{^ƍVtgǂĂȂvC[̈ړ
	if( CheckHitKey( KEY_INPUT_LSHIFT ) == 0 && ( inp.NowInput & PAD_INPUT_C ) == 0 )
	{
		// {^uv͂ꂽJ̌Ă猩čɈړ
		if( inp.NowInput & PAD_INPUT_LEFT  )
		{
			// ړxNgɁuv͂ꂽ̈ړxNgZ
			MoveVec = VAdd( MoveVec, LeftMoveVec ) ;

			// ړǂ̃tOuړvɂ
			MoveFlag = 1 ;
		}
		else
		// {^uv͂ꂽJ̌Ă猩ĉEɈړ
		if( inp.NowInput & PAD_INPUT_RIGHT )
		{
			// ړxNgɁuv͂ꂽ̈ړxNg𔽓]̂Z
			MoveVec = VAdd( MoveVec, VScale( LeftMoveVec, -1.0f ) ) ;

			// ړǂ̃tOuړvɂ
			MoveFlag = 1 ;
		}

		// {^uv͂ꂽJ̌ĂɈړ
		if( inp.NowInput & PAD_INPUT_UP    )
		{
			// ړxNgɁuv͂ꂽ̈ړxNgZ
			MoveVec = VAdd( MoveVec, UpMoveVec ) ;

			// ړǂ̃tOuړvɂ
			MoveFlag = 1 ;
		}
		else
		// {^uv͂ꂽJ̕Ɉړ
		if( inp.NowInput & PAD_INPUT_DOWN  )
		{
			// ړxNgɁuv͂ꂽ̈ړxNg𔽓]̂Z
			MoveVec = VAdd( MoveVec, VScale( UpMoveVec, -1.0f ) ) ;

			// ړǂ̃tOuړvɂ
			MoveFlag = 1 ;
		}

		// vC[̏ԂuWvvł͂ȂA{^PĂWv
		if( pl.State != 2 && ( inp.EdgeInput & PAD_INPUT_A ) )
		{
			// ԂuWvvɂ
			pl.State = 2 ;

			// x̑xZbg
			pl.JumpPower = PLAYER_JUMP_POWER ;

			// WvAj[V̍Đ
			Player_PlayAnim( 2 ) ;
		}
	}

	// ړ{^ꂽǂŏ𕪊
	if( MoveFlag )
	{
		// ړxNg𐳋K̂vC[ׂƂĕۑ
		pl.TargetMoveDirection = VNorm( MoveVec ) ;

		// vC[ׂxNgvC[̃Xs[h{̂ړxNgƂ
		MoveVec = VScale( pl.TargetMoveDirection, PLAYER_MOVE_SPEED ) ;

		// ܂Łu~܂vԂ
		if( pl.State == 0 )
		{
			// Aj[VĐ
			Player_PlayAnim( 1 ) ;

			// Ԃuvɂ
			pl.State = 1 ;
		}
	}
	else
	{
		// ̃t[ňړĂȂāAԂuv
		if( pl.State == 1 )
		{
			// ~Aj[VĐ
			Player_PlayAnim( 4 ) ;

			// Ԃu~vɂ
			pl.State = 0 ;
		}
	}

	// ԂuWvv̏ꍇ
	if( pl.State == 2 )
	{
		// x̑xd͕Z
		pl.JumpPower -= PLAYER_GRAVITY ;

		// ĂĊĐĂAj[V㏸p̂̂ꍇ
		if( pl.JumpPower < 0.0f && MV1GetAttachAnim( pl.ModelHandle, pl.PlayAnim1 ) == 2 )
		{
			// 悤̃Aj[VĐ
			Player_PlayAnim( 3 ) ;
		}

		// ړxNĝxx̑xɂ
		MoveVec.y = pl.JumpPower ;
	}

	// vC[̈ړɃf̕߂Â
	Player_AngleProcess() ;

	// ړxNgɃRWlvC[ړ
	Player_Move( MoveVec ) ;

	// Aj[V
	Player_AnimProcess() ;
}

// vC[̈ړ
void Player_Move( VECTOR MoveVector )
{
	int i, j, k ;						// ėpJE^ϐ
	int MoveFlag ;						// Ɉړǂ̃tO( O:ړĂȂ  P:ړ )
	int HitFlag ;						// |SɓǂLĂ̂Ɏgϐ( O:ĂȂ  P: )
	MV1_COLL_RESULT_POLY_DIM HitDim ;			// vC[̎͂ɂ|Soʂ铖蔻茋ʍ\
	int KabeNum ;						// ǃ|SƔfꂽ|S̐
	int YukaNum ;						// |SƔfꂽ|S̐
	MV1_COLL_RESULT_POLY *Kabe[ PLAYER_MAX_HITCOLL ] ;	// ǃ|SƔfꂽ|S̍\̂̃AhXۑĂ߂̃|C^z
	MV1_COLL_RESULT_POLY *Yuka[ PLAYER_MAX_HITCOLL ] ;	// |SƔfꂽ|S̍\̂̃AhXۑĂ߂̃|C^z
	MV1_COLL_RESULT_POLY *Poly ;				// |S̍\̂ɃANZX邽߂Ɏgp|C^( gȂĂς܂܂vOȂ̂ŁEEE )
	HITRESULT_LINE LineRes ;				// ƃ|SƂ̓蔻̌ʂ\
	VECTOR OldPos ;						// ړO̍W	
	VECTOR NowPos ;						// ړ̍W

	// ړO̍Wۑ
	OldPos = pl.Position ;

	// ړ̍WZo
	NowPos = VAdd( pl.Position, MoveVector ) ;

	// vC[̎͂ɂXe[W|S擾
	// ( o͈͈͂ړl )
	HitDim = MV1CollCheck_Sphere( stg.ModelHandle, -1, pl.Position, PLAYER_ENUM_DEFAULT_SIZE + VSize( MoveVector ) ) ;

	// xy 0.01f ȏړꍇ́uړvtOPɂ
	if( fabs( MoveVector.x ) > 0.01f || fabs( MoveVector.z ) > 0.01f )
	{
		MoveFlag = 1 ;
	}
	else
	{
		MoveFlag = 0 ;
	}

	// oꂽ|Sǃ|S( wyʂɐȃ|S )|S( wyʂɐł͂Ȃ|S )𔻒f
	{
		// ǃ|SƏ|S̐
		KabeNum = 0 ;
		YukaNum = 0 ;

		// oꂽ|S̐JԂ
		for( i = 0 ; i < HitDim.HitNum ; i ++ )
		{
			// wyʂɐǂ̓|S̖@̂xOɌȂ߂ǂŔf
			if( HitDim.Dim[ i ].Normal.y < 0.000001f && HitDim.Dim[ i ].Normal.y > -0.000001f )
			{
				// ǃ|SƔfꂽꍇłAvC[̂xW{PDO荂|Ŝݓ蔻s
				if( HitDim.Dim[ i ].Position[ 0 ].y > pl.Position.y + 1.0f ||
					HitDim.Dim[ i ].Position[ 1 ].y > pl.Position.y + 1.0f ||
					HitDim.Dim[ i ].Position[ 2 ].y > pl.Position.y + 1.0f )
				{
					// |S̐񋓂łEɒBĂȂ|Szɒǉ
					if( KabeNum < PLAYER_MAX_HITCOLL )
					{
						// |S̍\̂̃AhXǃ|S|C^zɕۑ
						Kabe[ KabeNum ] = &HitDim.Dim[ i ] ;

						// ǃ|S̐Z
						KabeNum ++ ;
					}
				}
			}
			else
			{
				// |S̐񋓂łEɒBĂȂ|Szɒǉ
				if( YukaNum < PLAYER_MAX_HITCOLL )
				{
					// |S̍\̂̃AhX|S|C^zɕۑ
					Yuka[ YukaNum ] = &HitDim.Dim[ i ] ;

					// |S̐Z
					YukaNum ++ ;
				}
			}
		}
	}

	// ǃ|SƂ̓蔻菈
	if( KabeNum != 0 )
	{
		// ǂɓǂ̃tO͏Ԃł́uĂȂvɂĂ
		HitFlag = 0 ;

		// ړǂŏ𕪊
		if( MoveFlag == 1 )
		{
			// ǃ|S̐JԂ
			for( i = 0 ; i < KabeNum ; i ++ )
			{
				// iԖڂ̕ǃ|S̃AhXǃ|S|C^z񂩂擾
				Poly = Kabe[ i ] ;

				// |SƃvC[ĂȂ玟̃JEg
				if( HitCheck_Capsule_Triangle( NowPos, VAdd( NowPos, VGet( 0.0f, PLAYER_HIT_HEIGHT, 0.0f ) ), PLAYER_HIT_WIDTH, Poly->Position[ 0 ], Poly->Position[ 1 ], Poly->Position[ 2 ] ) == FALSE ) continue ;

				// ɂ|SƃvC[ĂƂƂȂ̂ŁA|SɓtO𗧂Ă
				HitFlag = 1 ;

				// ǂɓǂɎՂȂړړ
				{
					VECTOR SlideVec ;	// vC[XChxNg

					// isxNgƕǃ|S̖@xNgɐȃxNgZo
					SlideVec = VCross( MoveVector, Poly->Normal ) ;

					// ZoxNgƕǃ|S̖@xNgɐȃxNgZoAꂪ
					// ̈ړǕ̈ړ𔲂xNg
					SlideVec = VCross( Poly->Normal, SlideVec ) ;

					// ړO̍Wɑ̂VȍWƂ
					NowPos = VAdd( OldPos, SlideVec ) ;
				}

				// VȈړWŕǃ|SƓĂȂǂ𔻒肷
				for( j = 0 ; j < KabeNum ; j ++ )
				{
					// jԖڂ̕ǃ|S̃AhXǃ|S|C^z񂩂擾
					Poly = Kabe[ j ] ;

					// Ă烋[v甲
					if( HitCheck_Capsule_Triangle( NowPos, VAdd( NowPos, VGet( 0.0f, PLAYER_HIT_HEIGHT, 0.0f ) ), PLAYER_HIT_WIDTH, Poly->Position[ 0 ], Poly->Position[ 1 ], Poly->Position[ 2 ] ) == TRUE ) break ;
				}

				// j  KabeNum ꍇ͂ǂ̃|SƂȂƂƂȂ̂
				// ǂɓtO|Ń[v甲
				if( j == KabeNum )
				{
					HitFlag = 0 ;
					break ;
				}
			}
		}
		else
		{
			// ړĂȂꍇ̏
			
			// ǃ|S̐JԂ
			for( i = 0 ; i < KabeNum ; i ++ )
			{
				// iԖڂ̕ǃ|S̃AhXǃ|S|C^z񂩂擾
				Poly = Kabe[ i ] ;

				// |SɓĂ瓖tO𗧂ĂŃ[v甲
				if( HitCheck_Capsule_Triangle( NowPos, VAdd( NowPos, VGet( 0.0f, PLAYER_HIT_HEIGHT, 0.0f ) ), PLAYER_HIT_WIDTH, Poly->Position[ 0 ], Poly->Position[ 1 ], Poly->Position[ 2 ] ) == TRUE )
				{
					HitFlag = 1 ;
					break ;
				}
			}
		}

		// ǂɓĂǂ牟os
		if( HitFlag == 1 )
		{
			// ǂ̉o݂ő吔JԂ
			for( k = 0 ; k < PLAYER_HIT_TRYNUM ; k ++ )
			{
				// ǃ|S̐JԂ
				for( i = 0 ; i < KabeNum ; i ++ )
				{
					// iԖڂ̕ǃ|S̃AhXǃ|S|C^z񂩂擾
					Poly = Kabe[ i ] ;

					// vC[ƓĂ邩𔻒
					if( HitCheck_Capsule_Triangle( NowPos, VAdd( NowPos, VGet( 0.0f, PLAYER_HIT_HEIGHT, 0.0f ) ), PLAYER_HIT_WIDTH, Poly->Position[ 0 ], Poly->Position[ 1 ], Poly->Position[ 2 ] ) == FALSE ) continue ;

					// ĂK苗vC[ǂ̖@Ɉړ
					NowPos = VAdd( NowPos, VScale( Poly->Normal, PLAYER_HIT_SLIDE_LENGTH ) ) ;

					// ړŕǃ|SƐڐGĂ邩ǂ𔻒
					for( j = 0 ; j < KabeNum ; j ++ )
					{
						// Ă烋[v𔲂
						Poly = Kabe[ j ] ;
						if( HitCheck_Capsule_Triangle( NowPos, VAdd( NowPos, VGet( 0.0f, PLAYER_HIT_HEIGHT, 0.0f ) ), PLAYER_HIT_WIDTH, Poly->Position[ 0 ], Poly->Position[ 1 ], Poly->Position[ 2 ] ) == TRUE ) break ;
					}

					// SẴ|SƓĂȂ炱Ń[vI
					if( j == KabeNum ) break ;
				}

				// i  KabeNum ł͂Ȃꍇ͑S̃|Sŉo݂OɑSĂ̕ǃ|SƐڐGȂȂƂƂȂ̂Ń[v甲
				if( i != KabeNum ) break ;
			}
		}
	}

	// |SƂ̓蔻
	if( YukaNum != 0 )
	{
		// Wv㏸̏ꍇ͏𕪊
		if( pl.State == 2 && pl.JumpPower > 0.0f )
		{
			float MinY ;

			// VɓԂ鏈s

			// ԒႢVɂԂׂ̔pϐ
			MinY = 0.0f ;

			// ǂ̃tO𓖂ĂȂӖOɂĂ
			HitFlag = 0 ;

			// |S̐JԂ
			for( i = 0 ; i < YukaNum ; i ++ )
			{
				// iԖڂ̏|S̃AhX|S|C^z񂩂擾
				Poly = Yuka[ i ] ;

				// 悩瓪̍܂ł̊ԂŃ|SƐڐGĂ邩ǂ𔻒
				LineRes = HitCheck_Line_Triangle( NowPos, VAdd( NowPos, VGet( 0.0f, PLAYER_HIT_HEIGHT, 0.0f ) ), Poly->Position[ 0 ], Poly->Position[ 1 ], Poly->Position[ 2 ] ) ;

				// ڐGĂȂ牽Ȃ
				if( LineRes.HitFlag == FALSE ) continue ;
				
				// Ƀ|SɓĂāA܂ŌoV|S荂ꍇ͉Ȃ
				if( HitFlag == 1 && MinY < LineRes.Position.y ) continue ;

				// |SɓtO𗧂Ă
				HitFlag = 1 ;

				// ڐGxWۑ
				MinY = LineRes.Position.y ;
			}

			// ڐG|Sǂŏ𕪊
			if( HitFlag == 1 )
			{
				// ڐGꍇ̓vC[̂xWڐGWɍXV
				NowPos.y = MinY - PLAYER_HIT_HEIGHT ;

				// x̑x͔]
				pl.JumpPower = -pl.JumpPower ;
			}
		}
		else
		{
			float MaxY ;

			// ~Wvł͂Ȃꍇ̏

			// |Sɓǂ̃tO|Ă
			HitFlag = 0 ;

			// ԍ|SɂԂׂ̔pϐ
			MaxY = 0.0f ;

			// |S̐JԂ
			for( i = 0 ; i < YukaNum ; i ++ )
			{
				// iԖڂ̏|S̃AhX|S|C^z񂩂擾
				Poly = Yuka[ i ] ;

				// Wvǂŏ𕪊
				if( pl.State == 2 )
				{
					// Wv̏ꍇ͓̐悩瑫菭ႢʒůԂœĂ邩𔻒
					LineRes = HitCheck_Line_Triangle( VAdd( NowPos, VGet( 0.0f, PLAYER_HIT_HEIGHT, 0.0f ) ), VAdd( NowPos, VGet( 0.0f, -1.0f, 0.0f ) ), Poly->Position[ 0 ], Poly->Position[ 1 ], Poly->Position[ 2 ] ) ;
				}
				else
				{
					// Ăꍇ͓̐悩炻ႢʒůԂœĂ邩𔻒( X΂ŗԂɈڍsĂ܂Ȃ )
					LineRes = HitCheck_Line_Triangle( VAdd( NowPos, VGet( 0.0f, PLAYER_HIT_HEIGHT, 0.0f ) ), VAdd( NowPos, VGet( 0.0f, -40.0f, 0.0f ) ), Poly->Position[ 0 ], Poly->Position[ 1 ], Poly->Position[ 2 ] ) ;
				}

				// ĂȂ牽Ȃ
				if( LineRes.HitFlag == FALSE ) continue ;

				// ɓ|SA܂Ōo|SႢꍇ͉Ȃ
				if( HitFlag == 1 && MaxY > LineRes.Position.y ) continue ;

				// |SɓtO𗧂Ă
				HitFlag = 1 ;

				// ڐGxWۑ
				MaxY = LineRes.Position.y ;
			}

			// |Sɓǂŏ𕪊
			if( HitFlag == 1 )
			{
				// ꍇ

				// ڐG|SňԍxWvC[̂xWɂ
				NowPos.y = MaxY ;

				// ẍړx͂O
				pl.JumpPower = 0.0f ;

				// Wvꍇ͒nԂɂ
				if( pl.State == 2 )
				{
					// ړĂǂŒn̏ԂƍĐAj[V𕪊򂷂
					if( MoveFlag )
					{
						// ړĂꍇ͑Ԃ
						Player_PlayAnim( 1 ) ;
						pl.State = 1 ;
					}
					else
					{
						// ړĂȂꍇ͗~Ԃ
						Player_PlayAnim( 4 ) ;
						pl.State = 0 ;
					}

					// n̓Aj[Ṽuh͍sȂ
					pl.AnimBlendRate = 1.0f ;
				}
			}
			else
			{
				// RWɓĂȂĊWvԂł͂Ȃꍇ
				if( pl.State != 2 )
				{
					// Wvɂ
					pl.State = 2 ;

					// ƂWv
					pl.JumpPower = PLAYER_FALL_UP_POWER ;

					// Aj[V͗̂̂ɂ
					Player_PlayAnim( 3 ) ;
				}
			}
		}
	}

	// VWۑ
	pl.Position = NowPos ;

	// vC[̃f̍WXV
	MV1SetPosition( pl.ModelHandle, pl.Position ) ;

	// ovC[̎͂̃|SJ
	MV1CollResultPolyDimTerminate( HitDim ) ;
}

// vC[̌ς鏈
void Player_AngleProcess( void )
{
	float TargetAngle ;			// ڕWpx
	float SaAngle ;				// ڕWpxƌ݂̊pxƂ̍

	// ڕW̕xNgpxlZo
	TargetAngle = atan2( pl.TargetMoveDirection.x, pl.TargetMoveDirection.z ) ;

	// ڕW̊pxƌ݂̊pxƂ̍o
	{
		// ŏ͒PɈZ
		SaAngle = TargetAngle - pl.Angle ;

		// 炠̍PWOxȏɂȂ邱Ƃ͖̂
		// ̒lPWOxȏɂȂĂC
		if( SaAngle < -PHI_F )
		{
			SaAngle += TWO_PHI_F ;
		}
		else
		if( SaAngle > PHI_F )
		{
			SaAngle -= TWO_PHI_F ;
		}
	}

	// px̍Oɋ߂Â
	if( SaAngle > 0.0f )
	{
		// vX̏ꍇ͈
		SaAngle -= PLAYER_ANGLE_SPEED ;
		if( SaAngle < 0.0f )
		{
			SaAngle = 0.0f ;
		}
	}
	else
	{
		// }CiX̏ꍇ͑
		SaAngle += PLAYER_ANGLE_SPEED ;
		if( SaAngle > 0.0f )
		{
			SaAngle = 0.0f ;
		}
	}

	// f̊pxXV
	pl.Angle = TargetAngle - SaAngle ;
	MV1SetRotationXYZ( pl.ModelHandle, VGet( 0.0f, pl.Angle + PHI_F, 0.0f ) ) ;
}

// vC[ɐVȃAj[VĐ
void Player_PlayAnim( int PlayAnim )
{
	// Đ̃[VQLf^b`
	if( pl.PlayAnim2 != -1 )
	{
		MV1DetachAnim( pl.ModelHandle, pl.PlayAnim2 ) ;
		pl.PlayAnim2 = -1 ;
	}

	// ܂ōĐ̃[VP̂̏QɈړ
	pl.PlayAnim2 = pl.PlayAnim1 ;
	pl.AnimPlayCount2 = pl.AnimPlayCount1 ;

	// VɎw̃[VfɃA^b`āAA^b`ԍۑ
	pl.PlayAnim1 = MV1AttachAnim( pl.ModelHandle, PlayAnim ) ;
	pl.AnimPlayCount1 = 0.0f ;

	// uh͍Đ̃[VQLł͂Ȃꍇ͂PDO( Đ̃[VPPOȌ )ɂ
	pl.AnimBlendRate = pl.PlayAnim2 == -1 ? 1.0f : 0.0f ;
}

// vC[̃Aj[V
void Player_AnimProcess( void )
{
	float AnimTotalTime ;		// ĐĂAj[V̑

	// uhPȉ̏ꍇ͂Pɋ߂Â
	if( pl.AnimBlendRate < 1.0f )
	{
		pl.AnimBlendRate += PLAYER_ANIM_BLEND_SPEED ;
		if( pl.AnimBlendRate > 1.0f )
		{
			pl.AnimBlendRate = 1.0f ;
		}
	}

	// ĐĂAj[VP̏
	if( pl.PlayAnim1 != -1 )
	{
		// Aj[V̑Ԃ擾
		AnimTotalTime = MV1GetAttachAnimTotalTime( pl.ModelHandle, pl.PlayAnim1 ) ;

		// ĐԂi߂
		pl.AnimPlayCount1 += PLAYER_PLAY_ANIM_SPEED ;

		// ĐԂԂɓBĂĐԂ[v
		if( pl.AnimPlayCount1 >= AnimTotalTime )
		{
			pl.AnimPlayCount1 = fmod( pl.AnimPlayCount1, AnimTotalTime ) ;
		}

		// ύXĐԂfɔf
		MV1SetAttachAnimTime( pl.ModelHandle, pl.PlayAnim1, pl.AnimPlayCount1 ) ;

		// Aj[VP̃fɑ΂锽fZbg
		MV1SetAttachAnimBlendRate( pl.ModelHandle, pl.PlayAnim1, pl.AnimBlendRate ) ;
	}

	// ĐĂAj[VQ̏
	if( pl.PlayAnim2 != -1 )
	{
		// Aj[V̑Ԃ擾
		AnimTotalTime = MV1GetAttachAnimTotalTime( pl.ModelHandle, pl.PlayAnim2 ) ;

		// ĐԂi߂
		pl.AnimPlayCount2 += PLAYER_PLAY_ANIM_SPEED ;

		// ĐԂԂɓBĂĐԂ[v
		if( pl.AnimPlayCount2 > AnimTotalTime )
		{
			pl.AnimPlayCount2 = fmod( pl.AnimPlayCount2, AnimTotalTime ) ;
		}

		// ύXĐԂfɔf
		MV1SetAttachAnimTime( pl.ModelHandle, pl.PlayAnim2, pl.AnimPlayCount2 ) ;

		// Aj[VQ̃fɑ΂锽fZbg
		MV1SetAttachAnimBlendRate( pl.ModelHandle, pl.PlayAnim2, 1.0f - pl.AnimBlendRate ) ;
	}
}

// vC[̉e`
void Player_ShadowRender( void )
{
	int i ;
	MV1_COLL_RESULT_POLY_DIM HitResDim ;
	MV1_COLL_RESULT_POLY *HitRes ;
	VERTEX3D Vertex[ 3 ] ;
	VECTOR SlideVec ;

	// CeBO𖳌ɂ
	SetUseLighting( FALSE ) ;

	// yobt@Lɂ
	SetUseZBuffer3D( TRUE ) ;

	// eNX`AhX[h CLAMP ɂ( eNX`̒[͒[̃hbgX )
	SetTextureAddressMode( DX_TEXADDRESS_CLAMP ) ;

	// vC[̒ɑ݂nʂ̃|S擾
	HitResDim = MV1CollCheck_Capsule( stg.ModelHandle, -1, pl.Position, VAdd( pl.Position, VGet( 0.0f, -PLAYER_SHADOW_HEIGHT, 0.0f ) ), PLAYER_SHADOW_SIZE ) ;

	// _f[^ŕωZbg
	Vertex[ 0 ].dif = GetColorU8( 255,255,255,255 ) ;
	Vertex[ 0 ].spc = GetColorU8( 0,0,0,0 ) ;
	Vertex[ 0 ].su = 0.0f ;
	Vertex[ 0 ].sv = 0.0f ;
	Vertex[ 1 ] = Vertex[ 0 ] ;
	Vertex[ 2 ] = Vertex[ 0 ] ;

	// ̒ɑ݂|S̐JԂ
	HitRes = HitResDim.Dim ;
	for( i = 0 ; i < HitResDim.HitNum ; i ++, HitRes ++ )
	{
		// |S̍W͒nʃ|S̍W
		Vertex[ 0 ].pos = HitRes->Position[ 0 ] ;
		Vertex[ 1 ].pos = HitRes->Position[ 1 ] ;
		Vertex[ 2 ].pos = HitRes->Position[ 2 ] ;

		// ƎグďdȂȂ悤ɂ
		SlideVec = VScale( HitRes->Normal, 0.5f ) ;
		Vertex[ 0 ].pos = VAdd( Vertex[ 0 ].pos, SlideVec ) ;
		Vertex[ 1 ].pos = VAdd( Vertex[ 1 ].pos, SlideVec ) ;
		Vertex[ 2 ].pos = VAdd( Vertex[ 2 ].pos, SlideVec ) ;

		// |S̕sxݒ肷
		Vertex[ 0 ].dif.a = 0 ;
		Vertex[ 1 ].dif.a = 0 ;
		Vertex[ 2 ].dif.a = 0 ;
		if( HitRes->Position[ 0 ].y > pl.Position.y - PLAYER_SHADOW_HEIGHT )
			Vertex[ 0 ].dif.a = 128 * ( 1.0f - fabs( HitRes->Position[ 0 ].y - pl.Position.y ) / PLAYER_SHADOW_HEIGHT ) ;

		if( HitRes->Position[ 1 ].y > pl.Position.y - PLAYER_SHADOW_HEIGHT )
			Vertex[ 1 ].dif.a = 128 * ( 1.0f - fabs( HitRes->Position[ 1 ].y - pl.Position.y ) / PLAYER_SHADOW_HEIGHT ) ;

		if( HitRes->Position[ 2 ].y > pl.Position.y - PLAYER_SHADOW_HEIGHT )
			Vertex[ 2 ].dif.a = 128 * ( 1.0f - fabs( HitRes->Position[ 2 ].y - pl.Position.y ) / PLAYER_SHADOW_HEIGHT ) ;

		// tul͒nʃ|SƃvC[̑΍W犄o
		Vertex[ 0 ].u = ( HitRes->Position[ 0 ].x - pl.Position.x ) / ( PLAYER_SHADOW_SIZE * 2.0f ) + 0.5f ;
		Vertex[ 0 ].v = ( HitRes->Position[ 0 ].z - pl.Position.z ) / ( PLAYER_SHADOW_SIZE * 2.0f ) + 0.5f ;
		Vertex[ 1 ].u = ( HitRes->Position[ 1 ].x - pl.Position.x ) / ( PLAYER_SHADOW_SIZE * 2.0f ) + 0.5f ;
		Vertex[ 1 ].v = ( HitRes->Position[ 1 ].z - pl.Position.z ) / ( PLAYER_SHADOW_SIZE * 2.0f ) + 0.5f ;
		Vertex[ 2 ].u = ( HitRes->Position[ 2 ].x - pl.Position.x ) / ( PLAYER_SHADOW_SIZE * 2.0f ) + 0.5f ;
		Vertex[ 2 ].v = ( HitRes->Position[ 2 ].z - pl.Position.z ) / ( PLAYER_SHADOW_SIZE * 2.0f ) + 0.5f ;

		// e|S`
		DrawPolygon3D( Vertex, 1, pl.ShadowHandle, TRUE ) ;
	}

	// onʃ|Šn
	MV1CollResultPolyDimTerminate( HitResDim ) ;

	// CeBOLɂ
	SetUseLighting( TRUE ) ;

	// yobt@𖳌ɂ
	SetUseZBuffer3D( FALSE ) ;
}

// Xe[W̏
void Stage_Initialize( void )
{
	// Xe[Wf̓ǂݍ
	stg.ModelHandle = MV1LoadModel( "ColTestStage.mqo" ) ;

	// fŜ̃RW̃ZbgAbv
	MV1SetupCollInfo( stg.ModelHandle, -1 ) ;
}

// Xe[W̌n
void Stage_Terminate( void )
{
	// Xe[Wf̌n
	MV1DeleteModel( stg.ModelHandle ) ;
}

// J̏
void Camera_Initialize( void )
{
	// J̏px͂PWOx
	cam.AngleH = PHI_F ;

	// px͂Ox
	cam.AngleV = 0.0f ;
}

// J̏
void Camera_Process( void )
{
	// pbĥR{^AVtgL[Ăꍇ̂݊pxύXs
	if( CheckHitKey( KEY_INPUT_LSHIFT ) || ( inp.NowInput & PAD_INPUT_C ) )
	{
		// uv{^Ă琅px}CiX
		if( inp.NowInput & PAD_INPUT_LEFT )
		{
			cam.AngleH -= CAMERA_ANGLE_SPEED ;

			// |PWOxȉɂȂpxl傫Ȃ肷Ȃ悤ɂRUOx𑫂
			if( cam.AngleH < -PHI_F )
			{
				cam.AngleH += TWO_PHI_F ;
			}
		}

		// uv{^Ă琅pxvX
		if( inp.NowInput & PAD_INPUT_RIGHT )
		{
			cam.AngleH += CAMERA_ANGLE_SPEED ;

			// PWOxȏɂȂpxl傫Ȃ肷Ȃ悤ɂRUOx
			if( cam.AngleH > PHI_F )
			{
				cam.AngleH -= TWO_PHI_F ;
			}
		}

		// uv{^Ă琂px}CiX
		if( inp.NowInput & PAD_INPUT_UP )
		{
			cam.AngleV -= CAMERA_ANGLE_SPEED ;

			// pxȉɂ͂ȂȂ悤ɂ
			if( cam.AngleV < -PHI_F / 2.0f + 0.6f )
			{
				cam.AngleV = -PHI_F / 2.0f + 0.6f ;
			}
		}

		// uv{^Ă琂pxvX
		if( inp.NowInput & PAD_INPUT_DOWN )
		{
			cam.AngleV += CAMERA_ANGLE_SPEED ;

			// pxȏɂ͂ȂȂ悤ɂ
			if( cam.AngleV > PHI_F / 2.0f - 0.6f )
			{
				cam.AngleV = PHI_F / 2.0f - 0.6f ;
			}
		}
	}

	// J̒_̓vC[WKlW
	cam.Target = VAdd( pl.Position, VGet( 0.0f, CAMERA_PLAYER_TARGET_HEIGHT, 0.0f ) ) ;

	// J̍W肷
	{
		MATRIX RotZ, RotY ;
		float Camera_Player_Length ;
		MV1_COLL_RESULT_POLY_DIM HRes ;
		int HitNum ;

		// ̉]͂x]
		RotY = MGetRotY( cam.AngleH ) ;

		// ̉]͂y] )
		RotZ = MGetRotZ( cam.AngleV ) ;

		// JvC[܂ł̏Zbg
		Camera_Player_Length = CAMERA_PLAYER_LENGTH ;

		// J̍WZo
		// wɃJƃvC[Ƃ̋LтxNg
		// ]( y] )Ɛ]( x] )čX
		// _̍W𑫂̂J̍W
		cam.Eye = VAdd( VTransform( VTransform( VGet( -Camera_Player_Length, 0.0f, 0.0f ), RotZ ), RotY ), cam.Target ) ;

		// _J̍W܂ł̊ԂɃXe[W̃|S邩ׂ
		HRes = MV1CollCheck_Capsule( stg.ModelHandle, -1, cam.Target, cam.Eye, CAMERA_COLLISION_SIZE );
		HitNum = HRes.HitNum ;
		MV1CollResultPolyDimTerminate( HRes ) ;
		if( HitNum != 0 )
		{
			float NotHitLength ;
			float HitLength ;
			float TestLength ;
			VECTOR TestPosition ;

			// 疳ʒu܂ŃvC[ɋ߂Â

			// |SɓȂZbg
			NotHitLength = 0.0f ;

			// |Sɓ鋗Zbg
			HitLength = Camera_Player_Length ;
			do
			{
				// 邩ǂeXg鋗Zbg( ȂƓ鋗̒ )
				TestLength = NotHitLength + ( HitLength - NotHitLength ) / 2.0f ;

				// eXgp̃JWZo
				TestPosition = VAdd( VTransform( VTransform( VGet( -TestLength, 0.0f, 0.0f ), RotZ ), RotY ), cam.Target ) ;

				// VWŕǂɓ邩eXg
				HRes = MV1CollCheck_Capsule( stg.ModelHandle, -1, cam.Target, TestPosition, CAMERA_COLLISION_SIZE );
				HitNum = HRes.HitNum ;
				MV1CollResultPolyDimTerminate( HRes ) ;
				if( HitNum != 0 )
				{
					// 瓖鋗 TestLength ɕύX
					HitLength = TestLength ;
				}
				else
				{
					// Ȃ瓖Ȃ TestLength ɕύX
					NotHitLength = TestLength ;
				}

				// HitLength  NoHitLength \ɋ߂ÂĂȂ烋[v
			}while( HitLength - NotHitLength > 0.1f ) ;

			// J̍WZbg
			cam.Eye = TestPosition ;
		}
	}

	// J̏CũJɔf
	SetCameraPositionAndTarget_UpVecY( cam.Eye, cam.Target ) ;
}

// `揈
void Render_Process( void )
{
	// Xe[Wf̕`
	MV1DrawModel( stg.ModelHandle ) ;

	// vC[f̕`
	MV1DrawModel( pl.ModelHandle ) ;

	// vC[̉e̕`
	Player_ShadowRender() ;
}

// WinMain
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	// EChE[hŋN
	ChangeWindowMode( TRUE ) ;

	// Cȕ
	if( DxLib_Init() < 0 )
		return -1 ;

	// vC[̏
	Player_Initialize() ;

	// Xe[W̏
	Stage_Initialize() ;

	// J̏
	Camera_Initialize() ;

	// `𗠉ʂɂ
	SetDrawScreen( DX_SCREEN_BACK ) ;

	// drbL[邩AEChE܂Ń[v
	while( ProcessMessage() == 0 && CheckHitKey( KEY_INPUT_ESCAPE ) == 0 )
	{
		// ʂNA
		ClearDrawScreen() ;

		// ͏
		Input_Process() ;

		// vC[̏
		Player_Process() ;

		// J̏
		Camera_Process() ;

		// `揈
		Render_Process() ;

		// ʂ̓e\ʂɔf
		ScreenFlip() ;
	}

	// vC[̌n
	Player_Terminate() ;

	// Xe[W̌n
	Stage_Terminate() ;

	// Cǔn
	DxLib_End() ;

	// \tgI
	return 0 ;
}
